#
# Contributed by Brendan Knox (brendan@zentropix.com).
#

#!/bin/sh
/bin/echo "Calibrating BUS Frequency..."
/bin/echo -n "Obtaining BUS Frequency..."
BUSF="`/bin/dmesg | /bin/grep 'system bus clock speed is ' | /usr/bin/head -1 | /usr/bin/awk -F' '  '{printf(\"%d\", $7 * 1000000)}'`"
if [ -z "$BUSF" ] 
then
	/bin/echo " Did not find a BUS Frequency!";
	exit;
fi
/bin/echo "$BUSF"
/bin/echo -n "Modifying include/rtai.h file..."
exten=`/bin/date +%d%m%Y`
cp include/rtai.h include/rtai.h.orig.$exten
/bin/sed -e "
# Replace BUS_FREQ with our new one.
s/^#define BUS_FREQ .*/#define BUS_FREQ $BUSF/
# Comment out of FREQ_APIC
s/^\(#define FREQ_APIC .*\)/\/\/\1/
# Uncomment FREQ_APIC line
s/\/\/\(#define FREQ_APIC ((BUS_FREQ + APIC_DIVISOR\/2)\/APIC_DIVISOR)\)/\1/
" include/rtai.h > include/rtai.h.mod
mv include/rtai.h.mod include/rtai.h
/bin/echo "ok"
/bin/echo ""
/bin/echo "Old include/rtai.h saved as include/rtai.h.orig.$exten"
