#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <sched.h>
#include "../../include/rtai_srq.h"

#define PRINT_REPEAT 100

void main(void)
{
	int srq, tick, count = 0, nextcount = 0;
	struct sched_param mysched;
	long long time0, time, dt;

	mysched.sched_priority = 99;

	if( sched_setscheduler( 0, SCHED_FIFO, &mysched ) == -1 ) {
	puts(" ERROR IN SETTING THE SCHEDULER UP");
	perror( "errno" );
	exit( 0 );
 	}       

	srq = rtai_open_srq(0xcacca);
	rtai_srq(srq, (unsigned int)&time0);
	tick = rtai_srq(srq, 1);
	dt = time0;

	while(1) {
		rtai_srq(srq, (unsigned int)&time);
		if (++count > nextcount) {
			nextcount += PRINT_REPEAT;
			printf("# %d TICK: %d TIME: %lld DTOT: %lld\n", nextcount, tick, time - time0, time - dt);
		dt = time;
		}
	}
}
