#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <rtai.h>
#include <rtai_sched.h>
#include <rtai_lxrt.h>

main()
{
	unsigned long mtsk_name = nam2num("MTSK");
	unsigned long btsk_name = nam2num("BTSK");
	unsigned long sem_name  = nam2num("SEM");
	unsigned long msg;

	RT_TASK *mtsk, *btsk;
	SEM *sem;

 	if (!(btsk = rt_task_init(nam2num("BTSK"), 0, 0))) {
		printf("CANNOT INIT BUDDY TASK\n");
		exit(1);
	}
	printf("BUDDY TASK: name = %lx, address = %p(%p).\n", btsk_name, btsk, this_rt_task);
	rt_sleep(rt_nano2count(1E9));

 	if (!(mtsk = rt_get_adr(nam2num("MTSK")))) {
		printf("CANNOT FIND MASTER TASK\n");
		exit(1);
	}

	printf("BUDDY TASK RESUMES MASTER TASK\n");
	rt_task_resume(mtsk);

	printf("BUDDY TASK SLEEP/LOOPS POLLING FOR SEM CREATED BY MASTER TASK\n");
 	while (!(sem = rt_get_adr(sem_name))) {
		rt_sleep(rt_nano2count(1E9));
	}
	printf("BUDDY TASK FOUND SEM, SLEEPS 1 s\n");
	rt_sleep(rt_nano2count(1E9));

	printf("BUDDY TASK SIGNALS MASTER TASK THROUGH SEM\n");
	rt_sem_signal(sem);

	printf("BUDDY TASK SLEEP/LOOPS POLLING FOR SEM DELETE BY MASTER TASK\n");
 	while ((sem = rt_get_adr(sem_name))) {
		rt_sleep(rt_nano2count(1E9));
	}

	printf("BUDDY TASK SENDS MESSAGE %lx TO MASTER TASK\n", 0xaaaaaaaa);
	rt_send(mtsk, 0xaaaaaaaa);

	printf("BUDDY TASK WAITS TO RECEIVE FROM MASTER TASK\n");
	rt_receive(mtsk, (void *)&msg);
	printf("BUDDY TASK RECEIVED MESSAGE %lx FROM MASTER TASK AND RETURNS %lx\n", msg, 0xbbbbbbbb);
	rt_return(mtsk, 0xbbbbbbbb);

	printf("BUDDY TASK WAITS A MESSAGE TO END SELF\n");
	rt_receive(mtsk, (void *)&msg);
	printf("BUDDY TASK RECEIVED MESSAGE TO END SELF %lx\n", msg);

	printf("BUDDY TASK DELETES ITSELF\n");
	rt_task_delete(btsk);

	printf("END BUDDY TASK\n");
}
